package me.demon.market.Util;


import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonPlugin.Util.ItemNameUtil;
import me.demon.market.main;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class uItems {

    public static ItemStack glass(String name) {
        ItemStack item = new ItemStack(160, 1, (short) 15);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    public static String getItemName(ItemStack item) {
        ItemStack items = item.clone();
        String name = "AIR";
        ItemMeta meta = items.getItemMeta();
        if (meta.getDisplayName() == null) {
            name = ItemNameUtil.getChineseName(items);
        } else {
            name = meta.getDisplayName();
        }
        return name;
    }

    public static ItemStack ShopItemsSell(String playName, ItemStack items, String Key, String Type, int Price, int ShelfTime) {
        String money = "§6$" + new DecimalFormat(",###.##").format(Price) + "金币";
        ItemStack item = items.clone();
        ItemMeta meta = item.getItemMeta();
        String itemName = getItemName(item);
        meta.setDisplayName("§b" + itemName + "§7(§r§f#" + Key + "§7)");
        List<String> lore = new ArrayList<>();
        if (!DemonAPI.itemIsLore(item)) {
            lore.addAll(Objects.requireNonNull(Objects.requireNonNull(items.getItemMeta()).getLore()));
        }
        lore.add("§7-------------------------");
        lore.add("§a§l* §7出售价格: " + money);
        lore.add("§a§l* §7出售数量: §f" + item.getAmount() + "个");
        lore.add("§a§l* §7物品主人: §f" + playName);
        lore.add("§a§l* §7下架时间: §f" + main.MinutesToCountdown(ShelfTime));
        lore.add(" ");
        lore.add("§e§l* §b左键双击 §7拍下此商品");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.addItemFlags(ItemFlag.HIDE_UNBREAKABLE);
        meta.addItemFlags(ItemFlag.HIDE_POTION_EFFECTS);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack 管理商品() {
        ItemStack item = new ItemStack(Material.CHEST);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§8« §b管理上架物品 §8»");
        List<String> lore = new ArrayList<>();
        lore.add(" §a§l★ §7点击打开 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack 出售商品() {
        ItemStack item = new ItemStack(Material.COOKED_FISH);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§c如何在§6贸易市场§c上架商品？");
        List<String> lore = new ArrayList<>();
        lore.add("§7将物品拿在手上");
        lore.add("§f输入命令§7“§e/pdd sell 价格§7”");
        lore.add("§8上架手续费: §72%");
        lore.add("§c如何将商品下架？");
        lore.add("§7点击左下角§b管理按钮§7即可下架商品");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack 排序方式(Player p) {
        ItemStack item = new ItemStack(Material.NETHER_STAR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§8« §e刷新市场 §8»");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★§7已上架: §6" + main.getUpMarketAmount(p.getName()) + "件");
        lore.add("§b§l★§7可上架: §c" + (main.getupSellAmount(p) - main.getUpMarketAmount(p.getName())) + "件");
        lore.add("§e§l★§7物品总数: §6" + main.KeyList.size() + "件");
        lore.add("§a§l★ §7点击刷新 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack 商品分类() {
        ItemStack item = new ItemStack(Material.REDSTONE);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§8« §d商品分类 §8»");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7点击打开 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack 贸易日志() {
        ItemStack item = new ItemStack(Material.BOOK_AND_QUILL);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("   §8« §e市场交易日志 §8»");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7左键查看购买记录 §a§l★");
        lore.add("§a§l★ §7右键查看出售记录 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Paper_Butt(String name) {
        ItemStack item = new ItemStack(Material.ARROW);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7点击翻页 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack 返回上一页() {
        ItemStack item = new ItemStack(Material.IRON_DOOR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§8« §a返回上一页 §8»");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7点击返回主页 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
