package me.demon.market.Gui;

import me.Demon.DemonPlugin.DemonAPI;
import me.demon.market.MGui.*;
import me.demon.market.Util.uItems;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class ItemTypeGui implements Listener {

    public static String inv_Title = "§l拼刀刀 §r| 请选择你要查看的分类";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getInventory().getType() == InventoryType.CHEST && inv_Title.equalsIgnoreCase(e.getView().getTitle())) {
            e.setCancelled(true);
            if (e.getRawSlot() >= 0 && e.getRawSlot() < 45) {
                ItemStack item = e.getCurrentItem();
                if (!DemonAPI.itemIsNull(item)) {
                    p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                    if (item.getTypeId() == 160) {
                        Market_Default.OpenGui(p, 1);
                        return;
                    }
                    if (e.getRawSlot() == 9) {
                        Market_Default.OpenGui(p, 1);
                    }
                    if (e.getRawSlot() == 11) {
                        Market_武器.OpenGui(p, 1);
                    }
                    if (e.getRawSlot() == 13) {
                        Market_防具.OpenGui(p, 1);
                    }
                    if (e.getRawSlot() == 15) {
                        Market_工具.OpenGui(p, 1);
                    }
                    if (e.getRawSlot() == 17) {
                        Market_食物.OpenGui(p, 1);
                    }
                    if (e.getRawSlot() == 27) {
                        Market_药水.OpenGui(p, 1);
                    }
                    if (e.getRawSlot() == 29) {
                        Market_交通.OpenGui(p, 1);
                    }
                    if (e.getRawSlot() == 31) {
                        Market_红石.OpenGui(p, 1);
                    }
                    if (e.getRawSlot() == 33) {
                        Market_方块.OpenGui(p, 1);
                    }
                    if (e.getRawSlot() == 35) {
                        Market_杂项.OpenGui(p, 1);
                    }
                }
            }
        }
    }

    public static void OpenItemsGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 45, inv_Title);
        for (int i = 0; i < 9; i++) {
            inv.setItem(i, uItems.glass("§7[[§c点击返回§7]]"));
        }
        for (int i = 36; i < 45; i++) {
            inv.setItem(i, uItems.glass("§7[[§c点击返回§7]]"));
        }
        inv.setItem(9, Show_Item(Material.BRICK, "默认分类"));
        inv.setItem(11, Show_Item(Material.GOLD_SWORD, "武器"));
        inv.setItem(13, Show_Item(Material.IRON_CHESTPLATE, "防具"));
        inv.setItem(15, Show_Item(Material.DIAMOND_AXE, "工具"));
        inv.setItem(17, Show_Item(Material.COOKED_BEEF, "食物"));

        inv.setItem(27, Show_Item(Material.BREWING_STAND_ITEM, "药水"));
        inv.setItem(29, Show_Item(Material.MINECART, "交通"));
        inv.setItem(31, Show_Item(Material.REDSTONE_BLOCK, "红石"));
        inv.setItem(33, Show_Item(Material.GRASS, "方块"));
        inv.setItem(35, Show_Item(Material.LAVA_BUCKET, "杂项"));
        p.openInventory(inv);
    }

    public static ItemStack Show_Item(Material material, String typeName) {
        ItemStack item = new ItemStack(material);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§e§l" + typeName);
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7点击选择 §a§l★");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.addItemFlags(ItemFlag.HIDE_POTION_EFFECTS);
        item.setItemMeta(meta);
        return item;
    }
}
