package me.demon.market.MGui;

import me.Demon.DemonPlugin.DemonAPI;
import me.demon.market.Gui.AdminGui;
import me.demon.market.Gui.ItemTypeGui;
import me.demon.market.MarketAPI;
import me.demon.market.Util.uItems;
import me.demon.market.main;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.List;

public class Market_方块 implements Listener {

    public static String inventory_Title = "§f§k§r§l拼刀刀市场 §r| §4谨防铁砧改名假货! §8#";

    @EventHandler
    public void onclick(InventoryClickEvent e){
        Player p = (Player) e.getWhoClicked();
        if(e.getInventory().getType() == InventoryType.CHEST && e.getView().getTitle().contains(inventory_Title)){
            e.setCancelled(true);
            int Pages = Integer.parseInt(e.getView().getTitle().replace(inventory_Title,""));
            if(e.getRawSlot() == 48){p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK,1,2);
                if(Pages >= 2 && Pages <= 5){
                    Market_方块.OpenGui(p,Pages - 1);} else {p.sendMessage(main.prefix+"§c已经是第一页了！");}
            }
            if(e.getRawSlot() == 50){p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK,1,2);
                if(Pages >= 1 && Pages <= 4){
                    Market_方块.OpenGui(p,Pages+1);} else {p.sendMessage(main.prefix+"§c已经是最后一页了！");}
            }
            // 查看交易日志
            if(e.getRawSlot() == 45){
                p.sendMessage(main.prefix+"§c暂不支持查看日志。");
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK,1,2);
            }
            // 打开管理商品
            if(e.getRawSlot() == 46){
                AdminGui.OpenGui(p);
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK,1,2);
            }
            // 刷新页面
            if(e.getRawSlot() == 49){
                Market_方块.OpenGui(p,Pages);
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK,1,2);
            }
            // 打开分类
            if(e.getRawSlot() == 52){
                ItemTypeGui.OpenItemsGui(p);
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK,1,2);
            }
            if(e.getRawSlot() >= 0 && e.getRawSlot() < 36){
                if (!DemonAPI.itemIsNull(e.getCurrentItem()) && !DemonAPI.itemIsLore(e.getCurrentItem())) {
                    if(e.getClick() == ClickType.DOUBLE_CLICK) {
                        ItemStack item = e.getCurrentItem();
                        ItemMeta meta = item.getItemMeta();
                        String itemName = meta.getDisplayName();
                        String key = itemName.split("#")[1].replace("§7)","");
                        MarketAPI.BuyItemEvent(p, key);
                    }
                }
            }
        }
    }

    public static void OpenGui(Player p,int Paper){
        Inventory inv = Bukkit.createInventory(null,54,inventory_Title+Paper);
        for (int i = 36;i<53;i++){
            inv.setItem(i, uItems.glass("§7[[§a▧§c▧§a▧§7]]"));
        }
        inv.setItem(45,uItems.贸易日志());
        inv.setItem(46,uItems.管理商品());
        inv.setItem(48,uItems.Paper_Butt("§a上一页"));
        inv.setItem(49,uItems.排序方式(p));
        inv.setItem(50,uItems.Paper_Butt("§a下一页"));
        inv.setItem(52,uItems.商品分类());
        inv.setItem(53,uItems.出售商品());
        List<String> New_KeyList = MarketAPI.New_KeyList("方块");
        if(New_KeyList.size() >= 1) {
            int amount = New_KeyList.size()-1;
            int addamount = Paper * 36;
            if(Paper == 1) {
                for (int i = amount; i > -1; i--) {
                    if(New_KeyList.get(i) == null){
                        break;
                    }
                    String key = New_KeyList.get(i);
                    String str = "Items."+key+".";
                    String Type = main.DataG.getString(str+"Type");
                    int Money = main.DataG.getInt(str+"Money");
                    String Seller = main.DataG.getString(str+"Seller");
                    int ShelfTime = main.DataG.getInt(str+"ShelfTime");
                    ItemStack items = main.DataG.getItemStack(str+"Item");
                    inv.addItem(uItems.ShopItemsSell(Seller,items,key,Type,Money,ShelfTime));
                }
            }else {
                for (int i = amount - (addamount - 36); i > (amount - addamount); i--) {
                    if(i >= 0) {
                        String key = New_KeyList.get(i);
                        String str = "Items."+key+".";
                        String Type = main.DataG.getString(str+"Type");
                        int Money = main.DataG.getInt(str+"Money");
                        String Seller = main.DataG.getString(str+"Seller");
                        int ShelfTime = main.DataG.getInt(str+"ShelfTime");
                        ItemStack items = main.DataG.getItemStack(str+"Item");
                        inv.addItem(uItems.ShopItemsSell(Seller,items,key,Type,Money,ShelfTime));
                    }
                }
            }
        }
        p.openInventory(inv);
    }

}
